#include "testlib.h"
#include <string>

/*
 * Аргументы (Обязательные): <длина S> <длина K>
 * Дополнительные: <вес для S> <вес для K> <вес вероятности K>[если есть вес, то - rnd(1, n)]
 * Тест:
 * Обычный генератор с вероятностью вставки k
*/

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    int length_s = opt<int>(2), length_k = opt<int>(3);
    int weight = 0, temp;
    if (argc > 4) {
        length_s = rnd.wnext(1, length_s + 1,  opt<int>(4));
    }
    if (argc > 5) {
        length_k = rnd.wnext(1, length_k + 1,  opt<int>(5));
    }
    if (argc > 6) {
        weight = opt<int>(6);
    }
    std::string k =  rnd.next("[a-zA-Z]{%d}", length_k);
    while (length_s) {
        if (length_s >= length_k && rnd.wnext(1, 100, weight) > 50) {
            std::cout << k;
            length_s -= length_k;
        } else {
            temp = rnd.next(1, std::min(length_k, length_s));
            std::cout << rnd.next("[a-zA-Z]{%d}", temp);
            length_s -= temp;
        }
    }
    std::cout << '\n' << k << std::endl;
}