#include "testlib.h"
#include <string>

/*
 * Аргументы (Обязательные): <длина S> <длина K>
 * Дополнительные: <вес для S> <вес для K> [если есть вес, то - rnd(1, n)]
 * Тест: Строка S это повторение строки K, не обязательно полное.
*/

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    int length_s = opt<int>(2);
    int length_k = opt<int>(3);
    if (argc > 3) {
        length_s = rnd.wnext(length_s + 1,  opt<int>(4));
    }
    if (argc > 4) {
        length_k = rnd.wnext(length_k + 1,  opt<int>(5));
    }
    std::string k = rnd.next("[a-zA-Z]{%d}", length_k);
    for (int _ = 0; _ < length_s / length_k; ++_) {
        std::cout << k;
    }
    std::cout << k.substr(length_s % length_k) << '\n';
    std::cout << k << std::endl;
}